﻿using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.VisualStudio.Package;
using Microsoft.VisualStudio.TextManager.Interop;
using Microsoft.VisualStudio;

namespace ManagedMyC
{
    public class MyCAuthoringScope : AuthoringScope
    {
        public MyCAuthoringScope( object parseResult )
        {
            ParseResult = parseResult;
            Resolver = new MyCResolver();
        }

        object ParseResult
        {
            get;
            set;
        }
        IASTResolver Resolver
        {
            get;
            set;
        }

        // ParseReason.QuickInfo
        public override string GetDataTipText( int line, int col, out TextSpan span )
        {
            span = new TextSpan();
            return null;
        }

        // ParseReason.CompleteWord
        // ParseReason.DisplayMemberList
        // ParseReason.MemberSelect
        // ParseReason.MemberSelectAndHilightBraces
        public override Declarations GetDeclarations( IVsTextView view, int line, int col, TokenInfo info, ParseReason reason )
        {
            IList<Declaration> declarations;
            switch ( reason )
            {
            case ParseReason.CompleteWord:
                declarations = Resolver.FindCompletions( ParseResult, line, col );
                break;

            case ParseReason.DisplayMemberList:
            case ParseReason.MemberSelect:
            case ParseReason.MemberSelectAndHighlightBraces:
                declarations = Resolver.FindMembers( ParseResult, line, col );
                break;

            default:
                throw new ArgumentException();
            }

            return new MyCDeclarations( declarations );
        }

        // ParseReason.GetMethods
        public override Methods GetMethods( int line, int col, string name )
        {
            return new MyCMethods( Resolver.FindMethods( ParseResult, line, col, name ) );
        }

        // ParseReason.Goto
        public override string Goto( VSConstants.VSStd97CmdID cmd, IVsTextView textView, int line, int col, out TextSpan span )
        {
            span = new TextSpan();
            return null;
        }
    }
}
