﻿using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.VisualStudio.Package;

namespace ManagedMyC
{
    public class MyCMethods : Methods
    {
        IList<Method> _methods;

        public MyCMethods( IList<Method> methods )
        {
            _methods = methods;
        }

        public override int GetCount()
        {
            return _methods.Count;
        }
        public override string GetName( int index )
        {
            return _methods[index].Name;
        }
        public override string GetDescription( int index )
        {
            return _methods[index].Description;
        }
        public override string GetType( int index )
        {
            return _methods[index].Type;
        }
        public override int GetParameterCount( int index )
        {
            return ( _methods[index].Parameters == null ) ? 0 : _methods[index].Parameters.Count;
        }
        public override void GetParameterInfo( int index, int paramIndex, out string name, out string display, out string description )
        {
            Parameter parameter = _methods[index].Parameters[paramIndex];
            name = parameter.Name;
            display = parameter.Display;
            description = parameter.Description;
        }

    }
}
